<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="贷款合同编号" name="contractCode">
						<a-input v-model:value="searchFormState.contractCode" placeholder="请输入贷款合同编号"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="放款单号" name="loanOrderNo">
						<a-input v-model:value="searchFormState.loanOrderNo" placeholder="放款单号"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="放款状态" name="loanState">
						<a-select v-model:value="searchFormState.loanState" placeholder="请选择放款状态" :options="loanStateOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="审批状态" name="bankOpApprovalState">
						<a-select v-model:value="searchFormState.bankOpApprovalState" placeholder="请选择放款状态" :options="bankOpApprovalStateOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<!--	<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotLoanGrantAdd')">
							<template #icon>
								<plus-outlined/>
							</template>
							新增
						</a-button>
						<a-button danger @click="deleteBatchDepotLoanGrant()" v-if="hasPerm('depotLoanGrantBatchDelete')">删除</a-button>-->
					<a-button type="primary" @click="exportTable()">
						<export-outlined/>
						导出
					</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action' ">
					<a @click="detailFormRef.onOpen(record)"><span>详情</span> </a>
					<a @click="fileFormRef.onOpen(Object.assign(record,{'addFlag':2,'removeFlag':2}))">
						<a-divider type="vertical"/>
						<span>文件</span>
					</a>
					<a @click="approvalStateForm.onOpen(record)" v-if="hasPerm('放款单二级审批') && record.bankOpApprovalState === '待审批'">
						<a-divider type="vertical"/>
						<span>审批</span></a>
					<!--<a-divider type="vertical" v-if="hasPerm(['depotLoanGrantEdit', 'depotLoanGrantDelete'], 'and')"/>
											<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotLoanGrant(record)">
											<a-button type="link" danger size="small" v-if="hasPerm('depotLoanGrantDelete')">删除</a-button>
										</a-popconfirm>-->
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<FileForm ref="fileFormRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
	<ApprovalForm ref="approvalForm" @successful="table.refresh(true)"/>
	<ApprovalStateForm ref="approvalStateForm" @successful="table.refresh(true)"/>
</template>

<script setup name="depotLoanGrant">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import ApprovalForm from './approvalForm.vue'
import ApprovalStateForm from './approvalStateForm.vue'
import depotLoanGrantApi from '@/api/biz/depotLoanGrantApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import FileForm from '../depotFile/formLeft.vue'
import DetailForm from './detailForm.vue'
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const approvalForm = ref()
const approvalStateForm = ref()
const fileFormRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '贷款合同编号',
		dataIndex: 'contractCode'
	},
	{
		title: '放款单号',
		dataIndex: 'loanOrderNo'
	},
	{
		title: '入库重量(吨)',
		dataIndex: 'orderDryWeight'
	},
	{
		title: '入库实际重量(吨)',
		dataIndex: 'orderWeight'
	},
	{
		title: '入库总金额(元)',
		dataIndex: 'orderAmount'
	},
	{
		title: '质押价格(元/吨)',
		dataIndex: 'loanPrice'
	},
	{
		title: '质押率(%)',
		dataIndex: 'loanRatio'
	},
	{
		title: '放款金额(元)',
		dataIndex: 'loanAmount'
	},
	{
		title: '放款状态',
		dataIndex: 'loanState'
	},
	{
		title: '审批',
		dataIndex: 'bankOpApprovalState'
	},
	{
		title: '审批时间',
		dataIndex: 'approvalTime'
	},
	{
		title: '申请时间',
		dataIndex: 'createTime'
	},
]
// 操作栏通过权限判断是否显示
//if (hasPerm(['depotLoanGrantEdit', 'depotLoanGrantDelete'])) {
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '100px'
})
//}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotLoanGrantApi.depotLoanGrantPage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotLoanGrant = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotLoanGrantApi.depotLoanGrantDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotLoanGrant = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotLoanGrantApi.depotLoanGrantDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 二级审批通过
const bankOpApprovalState = (record) => {
	depotLoanGrantApi.bankOpApproval({id: record.id, 'bankOpApprovalState': '已审批'}).then(() => {
		table.value.refresh(true)
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '贷款合同编号', '放款单号', '粮食种类', '入库重量（吨）', '入库实际重量（吨）', '入库总金额', '质押价格', '平均质押价格', '质押率(%)'
		, '放款金额', '放款状态', '车量', '审批状态', '审批时间', '审批信息', '审批员', '申请时间', '申请人']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.contractCode, m.loanOrderNo, m.grainGroup, m.orderDryWeight, m.orderWeight, m.orderAmount, m.loanPrice, m.loanPriceAvg, m.loanRatio
				, m.loanAmount, m.loanState, m.loanTruckCount, m.bankOpApprovalState, m.approvalTime, m.approvalMsg, m.approvalUserName, m.createTime, m.createUserName])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '放款单记录' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const loanStateOptions = tool.dictList('放款状态')
const bankOpApprovalStateOptions = tool.dictList('审批状态')
</script>
